<!doctype html>
<html>
<head>
    <title>Tor 0.2.1.9-alpha released | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor 0.2.1.9-alpha released | Tor Project">
    <meta property="og:description" content="Tor 0.2.1.9-alpha fixes many more bugs, some of them security-related....">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-0219-alpha-released/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor 0.2.1.9-alpha released
      </h1>
    <p class="meta">by phobos | January 5, 2009</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Tor 0.2.1.9-alpha fixes many more bugs, some of them security-related.</p>

<p><a href="https://www.torproject.org/download.html.en" rel="nofollow">https://www.torproject.org/download.html.en</a></p>

<p>Changes in version 0.2.1.9-alpha - 2008-12-25<br />
 <strong>New directory authorities:</strong></p>

<ul>
<li>gabelmoo (the authority run by Karsten Loesing) now has a new<br />
      IP address.</li>
</ul>

<p><strong>Security fixes:</strong></p>

<ul>
<li>Never use a connection with a mismatched address to extend a<br />
      circuit, unless that connection is canonical. A canonical<br />
      connection is one whose address is authenticated by the router's<br />
      identity key, either in a NETINFO cell or in a router descriptor.</li>
<li>Avoid a possible memory corruption bug when receiving hidden service<br />
      descriptors. Bugfix on 0.2.1.6-alpha.</li>
</ul>

<p><strong>Major bugfixes:</strong></p>

<ul>
<li>Fix a logic error that would automatically reject all but the first<br />
      configured DNS server. Bugfix on 0.2.1.5-alpha. Possible fix for<br />
      part of bug 813/868. Bug spotted by coderman.</li>
<li>When a stream at an exit relay is in state "resolving" or<br />
      "connecting" and it receives an "end" relay cell, the exit relay<br />
      would silently ignore the end cell and not close the stream. If<br />
      the client never closes the circuit, then the exit relay never<br />
      closes the TCP connection. Bug introduced in 0.1.2.1-alpha;<br />
      reported by "wood".</li>
<li>When we can't initialize DNS because the network is down, do not<br />
      automatically stop Tor from starting. Instead, retry failed<br />
      dns_inits() every 10 minutes, and change the exit policy to reject<br />
      *:* until one succeeds. Fixes bug 691.</li>
</ul>

<p>  <strong>Minor features:</strong></p>

<ul>
<li> Give a better error message when an overzealous init script says<br />
      "sudo -u username tor --user username". Makes Bug 882 easier for<br />
      users to diagnose.</li>
<li>When a directory authority gives us a new guess for our IP address,<br />
      log which authority we used. Hopefully this will help us debug<br />
      the recent complaints about bad IP address guesses.</li>
<li>Detect svn revision properly when we're using git-svn.</li>
<li>Try not to open more than one descriptor-downloading connection<br />
      to an authority at once. This should reduce load on directory<br />
      authorities. Fixes bug 366.</li>
<li>Add cross-certification to newly generated certificates, so that<br />
      a signing key is enough information to look up a certificate.<br />
      Partial implementation of proposal 157.</li>
<li>Start serving certificates by (identity digest, signing key digest)<br />
      pairs. Partial implementation of proposal 157.</li>
<li>Clients now never report any stream end reason except 'MISC'.<br />
      Implements proposal 148.</li>
<li>On platforms with a maximum syslog string length, truncate syslog<br />
      messages to that length ourselves, rather than relying on the<br />
      system to do it for us.</li>
<li>Optimize out calls to time(NULL) that occur for every IO operation,<br />
      or for every cell. On systems where time() is a slow syscall,<br />
      this fix will be slightly helpful.</li>
<li>Exit servers can now answer resolve requests for ip6.arpa addresses.</li>
<li>When we download a descriptor that we then immediately (as<br />
      a directory authority) reject, do not retry downloading it right<br />
      away. Should save some bandwidth on authorities. Fix for bug<br />
      888. Patch by Sebastian Hahn.</li>
<li>When a download gets us zero good descriptors, do not notify<br />
      Tor that new directory information has arrived.</li>
<li>Avoid some nasty corner cases in the logic for marking connections<br />
      as too old or obsolete or noncanonical for circuits.</li>
</ul>

<p>  <strong>Minor features (controller):</strong></p>

<ul>
<li>New CONSENSUS_ARRIVED event to note when a new consensus has<br />
      been fetched and validated.</li>
<li>When we realize that another process has modified our cached<br />
      descriptors file, print out a more useful error message rather<br />
      than triggering an assertion. Fixes bug 885. Patch from Karsten.</li>
<li>Add an internal-use-only __ReloadTorrcOnSIGHUP option for<br />
      controllers to prevent SIGHUP from reloading the<br />
      configuration. Fixes bug 856.</li>
</ul>

<p>  <strong>Minor bugfixes:</strong></p>

<ul>
<li>Resume using the correct "REASON=" stream when telling the<br />
      controller why we closed a stream. Bugfix in 0.2.1.1-alpha.</li>
<li>When a canonical connection appears later in our internal list<br />
      than a noncanonical one for a given OR ID, always use the<br />
      canonical one. Bugfix on 0.2.0.12-alpha. Fixes bug 805.<br />
      Spotted by rovv.</li>
<li>Clip the MaxCircuitDirtiness config option to a minimum of 10<br />
      seconds. Warn the user if lower values are given in the<br />
      configuration. Bugfix on 0.1.0.1-rc. Patch by Sebastian.</li>
<li>Clip the CircuitBuildTimeout to a minimum of 30 seconds. Warn the<br />
      user if lower values are given in the configuration. Bugfix on<br />
      0.1.1.17-rc. Patch by Sebastian.</li>
<li>Fix a race condition when freeing keys shared between main thread<br />
      and CPU workers that could result in a memory leak. Bugfix on<br />
      0.1.0.1-rc. Fixes bug 889.</li>
</ul>

<p>  <strong>Minor bugfixes (hidden services):</strong></p>

<ul>
<li>Do not throw away existing introduction points on SIGHUP (bugfix on<br />
      0.0.6pre1); also, do not stall hidden services because we're<br />
      throwing away introduction points; bugfix on 0.2.1.7-alpha. Spotted<br />
      by John Brooks. Patch by Karsten. Fixes bug 874.</li>
<li>Fix a memory leak when we decline to add a v2 rendezvous<br />
      descriptor to the cache because we already had a v0 descriptor<br />
      with the same ID. Bugfix on 0.2.0.18-alpha.</li>
</ul>

<p>  <strong>Deprecated and removed features:</strong></p>

<ul>
<li>RedirectExits has been removed. It was deprecated since<br />
      0.2.0.3-alpha.</li>
<li>Finally remove deprecated "EXTENDED_FORMAT" controller feature. It<br />
      has been called EXTENDED_EVENTS since 0.1.2.4-alpha.</li>
<li>Cell pools are now always enabled; --disable-cell-pools is ignored.</li>
</ul>

<p>  <strong>Code simplifications and refactoring:</strong></p>

<ul>
<li>Rename the confusing or_is_obsolete field to the more appropriate<br />
      is_bad_for_new_circs, and move it to or_connection_t where it<br />
      belongs.</li>
<li>Move edge-only flags from connection_t to edge_connection_t: not<br />
      only is this better coding, but on machines of plausible alignment,<br />
      it should save 4-8 bytes per connection_t. "Every little bit helps."</li>
<li>Rename ServerDNSAllowBrokenResolvConf to ServerDNSAllowBrokenConfig<br />
      for consistency; keep old option working for backward compatibility.</li>
<li>Simplify the code for finding connections to use for a circuit.</li>
</ul>

<p>Original signed announcement at <a href="http://archives.seul.org/or/talk/Jan-2009/msg00029.html" rel="nofollow">http://archives.seul.org/or/talk/Jan-2009/msg00029.html</a></p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-496"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-496" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>PETER (not verified)</span> said:</p>
      <p class="date-time">January 04, 2009</p>
    </div>
    <a href="#comment-496">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-496" class="permalink" rel="bookmark">Please update this 2 tor</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Please update this 2 tor browser bundle. thanx</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-503"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-503" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>AnonymousS (not verified)</span> said:</p>
      <p class="date-time">January 10, 2009</p>
    </div>
    <a href="#comment-503">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-503" class="permalink" rel="bookmark">Roger Dingledine recently</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Roger Dingledine recently said that file sharing consumes the majority of Tor's overall bandwidth, and that this is considered to be a problem. I was just wondering whether you shouldn't simply invite these users by encouraging a network of non-exit file sharing clients who could provide a wealth of middle nodes that would prop up the network, not clog the exit nodes, and improve anonymity for Tor's more serious uses.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-506"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-506" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">January 11, 2009</p>
    </div>
    <a href="#comment-506">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-506" class="permalink" rel="bookmark">NLnet not only funds Tor,</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>NLnet not only funds Tor, but also this one:<br />
<a href="http://www.nlnet.nl/project/anomos/" rel="nofollow">http://www.nlnet.nl/project/anomos/</a></p>
<p>Maybe the websiteshould say: If you want something for (legal ;-) ) anonymous File sharing, use Freenet, Gnunet, MUTE or any of the programs whith Ants in their logo.</p>
<p>You can find a more complete list here:<br />
<a href="http://www.planetpeer.de/wiki/index.php/Main_Page" rel="nofollow">http://www.planetpeer.de/wiki/index.php/Main_Page</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-1967"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-1967" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 30, 2009</p>
    </div>
    <a href="#comment-1967">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-1967" class="permalink" rel="bookmark">CircuitBuildTimeout</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I still think the user should be allowed to use CircuitBuildTimeouts all the way down to 1. A sensible user will set this figure as low as their network will allow, raising it until their response time for circuits is acceptable.</p>
<p>This is what I do.</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
